package org.jboss.security.plugins;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import java.security.Principal;
import java.security.PrivilegedAction;
import java.util.Iterator;
import java.util.Set;
import javax.security.auth.Subject;
import org.jboss.security.plugins.SubjectActions;

class CopySubjectAction implements PrivilegedAction {
  Subject fromSubject;
  
  Subject toSubject;
  
  boolean setReadOnly;
  
  CopySubjectAction(Subject fromSubject, Subject toSubject, boolean setReadOnly) {
    this.fromSubject = fromSubject;
    this.toSubject = toSubject;
    this.setReadOnly = setReadOnly;
  }
  
  public Object run() {
    Set principals = this.fromSubject.getPrincipals();
    Set principals2 = this.toSubject.getPrincipals();
    Iterator iter = principals.iterator();
    while (iter.hasNext())
      principals2.add(iter.next()); 
    Set privateCreds = this.fromSubject.getPrivateCredentials();
    Set privateCreds2 = this.toSubject.getPrivateCredentials();
    iter = privateCreds.iterator();
    while (iter.hasNext())
      privateCreds2.add(iter.next()); 
    Set publicCreds = this.fromSubject.getPublicCredentials();
    Set publicCreds2 = this.toSubject.getPublicCredentials();
    iter = publicCreds.iterator();
    while (iter.hasNext())
      publicCreds2.add(iter.next()); 
    if (this.setReadOnly == true)
      this.toSubject.setReadOnly(); 
    return null;
  }
}
